/*
 * Copyright (C) 1996 Michael Davidson.
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for any purpose and without fee is hereby
 * granted, provided that the above copyright notice appear in all
 * copies and that both that copyright notice and this permission
 * notice appear in supporting documentation.
 *
 * This software is provided "as is" without express or implied warranty.
 */

#pragma ident	"@(#)errors.c	1.3	99/02/18 SMI"

#include	<errno.h>
#include	<stdarg.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>

extern char emulator[];

/*
 * fatal(err, format, ...)	- print an error message and exit
 */
void
fatal(
    int		err,		/* system call error # or 0		*/
    char	*fmt,		/* message format string		*/
    ...				/* optional arguments			*/
    )
{
    va_list	args;

    va_start(args, fmt);
    if (emulator[0] != '\0')
	(void) fprintf(stderr, "%s: ", emulator);
    (void) fprintf(stderr, "fatal error: ");
    (void) vfprintf(stderr, fmt, args);
    if (err > 0)
	(void) fprintf(stderr, ": %s\n", strerror(err));
    else
	(void) fprintf(stderr, "\n");
    va_end(args);

    exit(1);
}

/*
 * warning(err, format, ...)	- print a warning message
 */
void
warning(
    int		err,		/* system call error # or 0		*/
    char	*fmt,		/* message format string		*/
    ...				/* optional arguments			*/
    )
{
    va_list	args;

    va_start(args, fmt);
    if (emulator[0] != '\0')
	(void) fprintf(stderr, "%s: ", emulator);
    (void) fprintf(stderr, "warning: ");
    (void) vfprintf(stderr, fmt, args);
    if (err > 0)
	(void) fprintf(stderr, ": %s\n", strerror(err));
    else
	(void) fprintf(stderr, "\n");
    va_end(args);
}
